package com.zplay.android.sdk.zplayad.ads.b;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.json.JSONException;
import org.json.JSONObject;

import com.zplay.android.sdk.zplayad.constants.Constants;
import com.zplay.android.sdk.zplayad.entity.ADResponse;
import com.zplay.android.sdk.zplayad.entity.ADSize;
import com.zplay.android.sdk.zplayad.entity.Failed;
import com.zplay.android.sdk.zplayad.entity.ReportEntity;
import com.zplay.android.sdk.zplayad.ui.MyWebView;
import com.zplay.android.sdk.zplayad.ui.ResFactory;
import com.zplay.android.sdk.zplayad.utils.ZplayDebug;
import com.zplay.android.sdk.zplayad.utils.display.DownloadAPkBrowserBuilder;
import com.zplay.android.sdk.zplayad.utils.display.DownloadAPkBrowserBuilder.OnChoseListener;
import com.zplay.android.sdk.zplayad.utils.display.ScreenModeHandler;
import com.zplay.android.sdk.zplayad.utils.display.WebViewUtils;
import com.zplay.android.sdk.zplayad.utils.display.WindowSizeUtils;
import com.zplay.android.sdk.zplayad.utils.file.DownloadHandler;
import com.zplay.android.sdk.zplayad.utils.http.HttpCallBack;
import com.zplay.android.sdk.zplayad.utils.http.Reporter;
import com.zplay.android.sdk.zplayad.utils.http.ZplayADWebHandler;
import com.zplay.android.sdk.zplayad.utils.other.AppInfoHandler;
import com.zplay.android.sdk.zplayad.utils.other.PhoneInfoHandler;
import com.zplay.android.sdk.zplayad.utils.other.PhoneInfoHandler.Location;
import com.zplay.android.sdk.zplayad.utils.sp.ADConfig;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;
import android.os.AsyncTask;
import android.os.Handler;
import android.telephony.CellLocation;
import android.telephony.TelephonyManager;
import android.telephony.cdma.CdmaCellLocation;
import android.telephony.gsm.GsmCellLocation;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.FrameLayout;
import android.widget.ImageView;

public class BannerAD
{

	private final int OUTTIME = 50000;
	private final String TAG = "BannerAD";
	
	private FrameLayout bannerBox;
	
	private Activity activity;
	private int bInterval;
	private int banner_width;
	private int banner_height;
	private BannerADListener listener;
	private Handler handler;
	/**是否没有被销毁*/
	private boolean isRun;
	private int request_width;
	private int request_height;
	private String adLocationID;
	
	private long last_request_time;
	private long last_show_time;

	private static final int BANNER_VIEW_ID = 0x20001;
	
	public BannerAD(Activity activity, ADSize size,
		BannerADListener listener)
	{
		checkNull(activity, size, listener);
		this.activity = activity;
		this.adLocationID = "";
		this.listener = listener;
		this.isRun = true;
		this.handler = new Handler();
		
		if (size.getType()==ADSize.TYPE_DIP)
		{
			banner_width = WindowSizeUtils.dip2px(activity, size.getWidth());
			banner_height = WindowSizeUtils.dip2px(activity, size.getHeight());
		}else{
			banner_width = size.getWidth();
			banner_height = size.getHeight();
		}
		
		request_width = banner_width;
		request_height = banner_height;

	}
	
	/**
	 * 给聚合时外部可调用请求广告
	 */
	public void requestBanner()
	{
		newBanner();
	}
	
	/**
	 * 创建控件后请求并加载广告
	 */
	private void newBanner()
	{
		last_request_time = System.currentTimeMillis();
		if (activity==null)
		{
			onBannerRequestFailed(Failed.FAILED_REQUEST_PARAMS_ERROR);
			return;
		}
		bInterval = ADConfig.getInt(activity, ADConfig.KEY.INT_BINTERVAL);
		//===============================================================
		final ZplayADWebHandler handler = new ZplayADWebHandler(Constants.url.getBannerUrl(), activity);
		
		AsyncTask<Void, Void, Boolean> async = new AsyncTask<Void, Void, Boolean>()	{

			@Override
			protected Boolean doInBackground(Void... params)
			{
				try
				{
					handler.addValue("appKey", ADConfig.getString(activity, ADConfig.KEY.STRING_APPKEY));
					handler.addValue("uuid", ADConfig.getString(activity, ADConfig.KEY.STRING_UUID));
					handler.addValue("adWidth", request_width);
					handler.addValue("adHeight", request_height);
					handler.addValue("adType", Constants.adtype.AD_TYPE_BANNER);
					handler.addValue("screenMode", ScreenModeHandler.getScreenMode(activity));
					handler.addValue("initBackData", ADConfig.getString(activity, ADConfig.KEY.STRING_INITBACKDATA));
					handler.addValue("iswifi", ZplayADWebHandler.isWifiContected(activity)?1:0);
					handler.addValue("adLocationID", adLocationID);
					handler.addValue("plmn", PhoneInfoHandler.getPLMN(activity));
			        handler.addValue("sdkVersion", Constants.VERSION);
			        handler.addValue("osVersion", PhoneInfoHandler.getAndroidVersionCode());
			        handler.addValue("netEnv", PhoneInfoHandler.getNetEnv(activity));
			        
			        handler.addValue("brand", PhoneInfoHandler.getManufacture());//1.3.0.2
			        handler.addValue("make", PhoneInfoHandler.getBrand());//1.3.0.2
			        
					//============================WIFI列表============================
			        WifiManager wifi = (WifiManager) activity.getSystemService(Context.WIFI_SERVICE);
			        List<ScanResult> results = wifi.getScanResults();
			        int length = results.size();
			        List<String> wifiList = new ArrayList<String>();
			        for (int i = 0; i < length; i++)
					{
			        	wifiList.add(results.get(i).SSID); 
					}
			        handler.addValue("wifiList", wifiList);
			        //============================WIFI列表============================
			        
			        //============================基站信息============================
			        TelephonyManager tele = (TelephonyManager) activity.getSystemService(Context.TELEPHONY_SERVICE);
			        CellLocation cellLocation = tele.getCellLocation();
			        int cid = 0;
			        if (cellLocation!=null && cellLocation instanceof GsmCellLocation)
					{
			        	ZplayDebug.v(TAG, "GSM");
			        	cid = ((GsmCellLocation)cellLocation).getCid();
					}
			        if (cellLocation!=null && cellLocation instanceof CdmaCellLocation)
					{
			        	cid = ((CdmaCellLocation)cellLocation).getBaseStationId();
			        	ZplayDebug.v(TAG, "CDMA");
					}
			        handler.addValue("cellInfo", cid);
			        //============================基站信息============================
			        
			        //============================包名============================
			        String packageName = AppInfoHandler.getPackageName(activity);
			        handler.addValue("packageName", packageName);
			        //============================包名============================
			        
			        //=======================判断权限决定是否提交位置信息==========================
			        boolean has_coarse_location = false;
			        boolean has_fine_location = false;
			    	PackageManager manager = activity.getPackageManager();
					PackageInfo info = null;
					try
					{
						info = manager.getPackageInfo(packageName, PackageManager.GET_PERMISSIONS);
					} catch (Exception e)
					{
						e.printStackTrace();
					}
					String[] permissions = info.requestedPermissions;
					for (String p : permissions)
					{
						if ("android.permission.ACCESS_COARSE_LOCATION".equals(p))
						{
							has_coarse_location = true;
						}
						if ("android.permission.ACCESS_FINE_LOCATION".equals(p))
						{
							has_fine_location = true;
						}
					}
					if (has_fine_location && has_coarse_location)
					{
						ZplayDebug.v(TAG, "提交位置");
						Location location = PhoneInfoHandler.getLocation(activity);
				        handler.addValue("lat", location.lat);
				        handler.addValue("lng", location.lng);
					}else{
						ZplayDebug.v(TAG, "不提交位置");
						handler.addValue("lat", "0.0");
				        handler.addValue("lng", "0.0");
					}
					//=====================判断权限决定是否提交位置信息=========================
					return true;
				} catch (Exception e)
				{
					ZplayDebug.e(TAG, "广告数据不合法", e);
					return false;
				}
			}
			
			@Override
			protected void onPostExecute(Boolean result)
			{
				if (result!=null && !result)
				{
					onBannerRequestFailed(Failed.FAILED_REQUEST_PARAMS_ERROR);
					ZplayDebug.e(TAG, "参数获取错误");
					return;
				}
				handler.request(new HttpCallBack()
				{

					@Override
					public void onCallBack(String json, String msg)
					{
						if (isRun)
						{
							if (json==null)
							{
								onBannerRequestFailed(Failed.FAILED_REQUEST_OUTTIME);
								return;
							}
							try
							{
								JSONObject jobj = new JSONObject(json);
								String string_data = jobj.getString("data");
								if (string_data==null || "".equals(string_data) || "null".equals(string_data))
								{
									onBannerRequestFailed(Failed.FAILED_REQUEST_NO_FILL);
									ZplayDebug.e(TAG, "Banner 无广告");
									return;
								}
								JSONObject data = jobj.getJSONObject("data");
								ADResponse response = new ADResponse();
								response.setRequestId(data.getString("requestId"));
								response.setRequestBackData(data.getString("requestBackData"));
								response.setAdId(data.getString("adId"));
								response.setAdWidth(data.getInt("adWidth"));
								response.setAdHeight(data.getInt("adHeight"));
								response.setAdType(data.getInt("adType"));
								response.setHtml(data.getString("html"));
								response.setUrl(data.getString("url"));
								response.setResUrl(data.getString("resUrl"));
								response.setDisplayTrackerUrl(data.getString("displayTrackerUrl"));
								response.setClickTrackerUrl(data.getString("clickTrackerUrl"));
								response.setClickType(data.getInt("clickType"));
								response.setSupportPreDoload(data.getInt("supportPreDoload"));
								
								JSONObject config_obj = data.getJSONObject("config");
								bInterval = config_obj.getInt("bInterval");
								ADConfig.putValue(activity, ADConfig.KEY.INT_BINTERVAL, bInterval);
								
								response.setDownloadPackageName(data.getString("downloadPackageName"));
								response.setDownloadFileName(data.getString("downloadFileName"));
								response.setDownloadVersion(data.getInt("downloadVersion"));
								response.setIsServerSupport(data.getInt("isServerSupport"));
								
								bannerBox = new FrameLayout(activity);
								bannerBox.setTag(response);
								
								//==============================尺寸处理=================================
								
								ZplayDebug.v(TAG, "处理后的容器尺寸为："+banner_width+"x"+banner_height);
								
								if (banner_width==0 || banner_height==0)
								{
									onBannerShowFailed(Failed.FAILED_SHOW_UNPARSING);
									ZplayDebug.e(TAG, "Banner Banner请求失败");
									return;
								}
								
								ADSize webSize = handleBannerSize(response.getAdWidth(), response.getAdHeight());
								FrameLayout.LayoutParams params_web = new FrameLayout.LayoutParams(webSize.getWidth(), webSize.getHeight());
								params_web.gravity = Gravity.CENTER;
								WebView bannerView = WebViewUtils.buildWebViewWithTransparentBackground(activity);
								bannerView.setWebViewClient(new MyWebViewClient());
								bannerView.setLayoutParams(params_web);
								
								//============================广告标识处理===================================
								//创建广告标识
								ImageView iv_flag = new ImageView(activity);
								Drawable drawable_flag = ResFactory.getDrawableByAssets("zplayad_ad_flag", activity);
								iv_flag.setImageDrawable(drawable_flag);
								FrameLayout.LayoutParams param_iv_flag = new FrameLayout.LayoutParams(
										WindowSizeUtils.dip2px(activity, 34), WindowSizeUtils.dip2px(activity, 16));
								param_iv_flag.gravity = Gravity.RIGHT|Gravity.BOTTOM;
								iv_flag.setLayoutParams(param_iv_flag);
								int wc = (banner_width-webSize.getWidth())/2;
								int hc = (banner_height-webSize.getHeight())/2;
								
								FrameLayout.LayoutParams params_flag = (FrameLayout.LayoutParams) iv_flag.getLayoutParams();
								params_flag.rightMargin = wc;
								params_flag.bottomMargin = hc;
								iv_flag.setLayoutParams(params_flag);
								ZplayDebug.v(TAG, "wc="+wc+",hc="+hc);
								//============================广告标识处理===================================
								
								
								FrameLayout.LayoutParams params_box = new FrameLayout.LayoutParams(banner_width, banner_height);
								params_box.gravity = Gravity.CENTER;
								bannerBox.setLayoutParams(params_box);
								//===============================================================
								bannerView.setId(BANNER_VIEW_ID);
								bannerBox.addView(bannerView);
								bannerBox.addView(iv_flag);
								
								bannerView.loadDataWithBaseURL(null, response.getHtml(), "text/html", "utf-8", null);
								
							} catch (JSONException e)
							{
								onBannerRequestFailed(Failed.FAILED_REQUEST_OUTTIME);
								ZplayDebug.e(TAG, "Banner Banner请求失败", e);
							}
						}
					}
				});
				super.onPostExecute(result);
			}
			
		};
		
		async.execute();
		
	}
	
	/**
	 * 将banner尺寸控制在容器内
	 * @param img_width
	 * @param img_height
	 * @return
	 */
	private ADSize handleBannerSize(float img_width, float img_height){
		ZplayDebug.w(TAG, "处理前的banner尺寸为:"+img_width+":"+img_height);
		float c_width = banner_width;
		float c_height = banner_height;
		
		float f_w = 0;
		float f_h = 0;
		//超出的等比缩小
		if (img_width>c_width)
		{
			float pro = c_width/img_width;
			f_h = img_height*pro;
			f_w = c_width;
		}
		
		if (f_h>c_height)
		{
			float pro = c_height/f_h;
			f_w = f_w*pro;
			f_h = c_height;
		}
		
		/*if (img_height>c_height)
		{
			float pro = c_height/img_height;
			f_w = img_width*pro;
			f_h = c_height;
		}*/
		
		//较小的等比放大
		if (f_w==0 && f_h==0)
		{
			float c_pro = c_width/c_height;
			float i_pro = img_width/img_height;
			if (c_pro>i_pro)
			{
				f_h = (int)c_height;
				f_w = (int)(c_height*i_pro);
			}else{
				f_w = (int)c_width;
				f_h = (int)(c_width/i_pro);
			}
		}
		ZplayDebug.w(TAG, "处理后的banner尺寸为:"+f_w+":"+f_h); 
		return new ADSize((int)f_w, (int)f_h);
	}
	
	
	/**
	 * 展示广告
	 */
	private void showBanner()
	{
		if (isRun)
		{
			ZplayDebug.v(TAG, "展示Banner");
			onBannerShow(bannerBox, "展示成功");
		}
	}
	
	
	public void destory(){
		isRun = false;
		if (bannerBox!=null)
		{
			bannerBox.removeAllViews();
			bannerBox = null;
		}
		activity = null;
		handler = null;
		listener = null;
	}
	
//	public void pause(){
//		isPause = true;
//	}
//	
//	public void resume(){
//		isPause = false;
//	}

	private void checkNull(Activity activity, ADSize size, BannerADListener listener)
	{
		if (activity==null)
		{
			throw new RuntimeException("The param \"activity\" should not be null!!");
		}
//		if (container==null)
//		{
//			throw new RuntimeException("The param \"container\" should not be null!!");
//		}
		if (size==null)
		{
			throw new RuntimeException("The param \"size\" should not be null!!");
		}
		if (listener==null)
		{
			throw new RuntimeException("The param \"listener\" should not be null!!");
		}
	}
	
	private class MyWebViewClient extends WebViewClient
	{
		
		private boolean isFinish;
		private boolean isOutTime;
		
		@Override
		public void onPageStarted(final WebView view, String url, Bitmap favicon)
		{
			isFinish = false;
			isOutTime = false;
			//超时处理
			if (isRun)
			{
				handler.postDelayed(new Runnable()
				{
					public void run()
					{
						if(view != null){
							onOutTime(view);
						}
					}
				}, OUTTIME);
			}
		}
		
		@Override
		public void onPageFinished(final WebView view, final String url)
		{
			if (isOutTime)
			{
				return;
			}
			if (isRun) 
			{
				int progress = view.getProgress();
				ZplayDebug.v(TAG, "Banner进度="+progress+"%");
				if (progress>=100 && !isFinish)
				{
					onBannerRequest("");
					ZplayDebug.v(TAG, "banner加载成功");
					showBanner();
					isFinish = true;
				}else{
					handler.postDelayed(new Runnable()
					{
						@Override
						public void run()
						{
							ZplayDebug.v(TAG, "过1秒后再次检测进度");
							if(view != null && url != null){
								MyWebViewClient.this.onPageFinished(view, url);
							}
						}
					}, 1000);
				}
			}
		}

		@Override
		public boolean shouldOverrideUrlLoading(WebView view, String url)
		{
			final ADResponse response = (ADResponse) view.getTag();
			if (response.getIsServerSupport() == 0)
			{
				ZplayDebug.v(TAG, "服务器无法处理，跳转地址为：" + url);
				response.setResUrl(url);
			}else if(url.contains("clickFlag=zplay")){
				ZplayDebug.v(TAG, "检测到跳转 url="+url);
			}else{
				return true;
			}
			try {
				onBannerClick();				
			} catch (Exception e) {
			}			
			
			int clickType = response.getClickType();
			switch (clickType)
			{
			case Constants.clicktype.CLICK_TYPE_DOWNLOAD:			//点击下载
				boolean wifiContected = ZplayADWebHandler.isWifiContected(activity);
				if (wifiContected)
				{
					ZplayDebug.v(TAG, "点击下载");
					DownloadHandler.startDownload(activity, response);
				}else{
					DownloadAPkBrowserBuilder.showConfirmDialog(activity, new OnChoseListener()
					{
						@Override
						public void onChose(boolean isConfirm)
						{
							if (isConfirm)
							{
								ZplayDebug.v(TAG, "点击下载");
								DownloadHandler.startDownload(activity, response);
							}else{
								DownloadAPkBrowserBuilder.reportCancel(activity, response);
							}
						}
					});
				}
				break;
			case Constants.clicktype.CLICK_TYPE_EXPLORER:			//打开浏览器
				ZplayDebug.v(TAG, "点击打开网页");
				DownloadAPkBrowserBuilder.openDownloadAPKBrowser(activity, response, null);
				break;
			case Constants.clicktype.CLICK_TYPE_SYSTEM_EXPLORER:	//打开系统浏览器
				ZplayDebug.v(TAG, "点击打开系统浏览器");
				Uri uri = Uri.parse(response.getResUrl());
				Intent intent = new Intent(Intent.ACTION_VIEW, uri);
				try
				{
					activity.startActivity(intent);
				} catch (Exception e)
				{
					ZplayDebug.v(TAG, "无法调用系统浏览器，改用内置浏览器");
					DownloadAPkBrowserBuilder.openDownloadAPKBrowser(activity, response, null);
				}
				break;
			default:
				break;
			}
			return true;
		}
		
		/**
		 * 超时处理 
		 */
		public void onOutTime(WebView view){
			if (!isFinish && isRun)
			{
				isOutTime = true;
				if (view!=null)
				{
					view.stopLoading();
				}
				onBannerShowFailed(Failed.FAILED_SHOW_OUTTIME);
			}
		}
	}
	
//	@Override
	public void onBannerRequest(String msg)
	{
		if (listener != null)
		{
			listener.onBannerRequest(msg);
		}
	}

//	@Override
	public void onBannerRequestFailed(Failed failed)
	{
		if (listener != null)
		{
			listener.onBannerRequestFailed(failed.getMsg());
		}
		int code = failed.getCode();
		if (code>100)
		{
			return;
		}
		try
		{
			ADResponse response = null;
			if (bannerBox!=null)
			{
				Object obj = bannerBox.getTag();
				if (obj!=null)
				{
					response = (ADResponse) obj;
				}
			}
			ReportEntity entity = new ReportEntity(
					ADConfig.getString(activity, ADConfig.KEY.STRING_APPKEY),
					ADConfig.getString(activity, ADConfig.KEY.STRING_UUID), 
					response==null?"":response.getRequestId(), 
					response==null?"":response.getAdId(),
					Constants.eventtype.AD_EVENT_REQUEST, 
					1, // 屏幕状态：默认1
					9999, // 显示时长：默认9999
					1, // 显示状态：默认1
					ADConfig.getString(activity, ADConfig.KEY.STRING_INITBACKDATA), 
					response==null?
							"{\"adPrice\":\"\",\"adChannel\":\"\",\"sspId\":\"\",\"adType\":\"2\",\"adLocationID\":\"\"}"
							:
							response.getRequestBackData(),
					response==null?"":response.getDisplayTrackerUrlString(),
					response==null?"":response.getClickTrackerUrlString(),
					null,0,0,1,failed.getCode());	//1.3.0.2
			Reporter.reportEvent(activity, entity);
		} catch (Exception e)
		{
			ZplayDebug.e(TAG, "onBannerRequestFailed report error",e);
		}
	}

	public void onBannerShow(View view, String msg)
	{
		if (listener != null)
		{
			listener.onBannerShow(view, msg);
		}
		last_show_time = System.currentTimeMillis();
		try
		{
			ADResponse response = (ADResponse) bannerBox.getTag();
			ReportEntity entity = new ReportEntity(
					ADConfig.getString(activity, ADConfig.KEY.STRING_APPKEY),
					ADConfig.getString(activity, ADConfig.KEY.STRING_UUID), 
					response.getRequestId(), 
					response.getAdId(),
					Constants.eventtype.AD_EVENT_SHOW, 
					1, // 屏幕状态：默认1
					9999, // 显示时长：默认9999
					1, // 显示状态：默认1
					ADConfig.getString(activity, ADConfig.KEY.STRING_INITBACKDATA), 
					response.getRequestBackData(),
					response.getDisplayTrackerUrlString(),
					response.getClickTrackerUrlString(),
					null,0,
					last_show_time-last_request_time,//请求到展示时长	1.3.0.2
					0,0
					);
			Reporter.reportEvent(activity, entity);
		} catch (Exception e)
		{
			ZplayDebug.e(TAG, "onBannerShow report error",e);
		}
	}
	
//	@Override
	public void onBannerShowFailed(Failed failed)
	{
		/*if (bInterval > 0 && bInterval<9999)
		{
			cycleBannerAD(bInterval);
		}*/
		
		if (listener != null && failed != null)
		{
			listener.onBannerShowFailed(failed.getMsg());
		}
		try
		{
			ADResponse response = null;
			if (bannerBox!=null)
			{
				Object obj = bannerBox.getTag();
				if (obj!=null)
				{
					response = (ADResponse) obj;
				}
			}
			ReportEntity entity = new ReportEntity(
					ADConfig.getString(activity, ADConfig.KEY.STRING_APPKEY),
			        ADConfig.getString(activity, ADConfig.KEY.STRING_UUID), 
			        response.getRequestId(), 
			        response.getAdId(),
			        Constants.eventtype.AD_EVENT_SHOW, 
			        1, // 屏幕状态：默认1
			        9999, // 显示时长：默认9999
			        1, // 显示状态：默认1
			        ADConfig.getString(activity, ADConfig.KEY.STRING_INITBACKDATA), 
			        response.getRequestBackData(),
			        response.getDisplayTrackerUrlString(),
			        response.getClickTrackerUrlString(),
			        null,0,0,1,failed.getCode()	//1.3.0.2
					);
			Reporter.reportEvent(activity, entity);
		} catch (Exception e)
		{
			ZplayDebug.e(TAG, "onBannerShowFailed report error",e);
		}
		
	}

//	@Override
	public void onBannerClick()
	{
		if (listener != null)
		{
			listener.onBannerClick();
		}
		long currentTimeMillis = System.currentTimeMillis();
		try
		{
			ADResponse response = (ADResponse) bannerBox.getTag();
			View bannerView = bannerBox.findViewById(BANNER_VIEW_ID);
			
			float[] area = ((MyWebView)bannerView).getLastTouchArea();
			LayoutParams params = bannerView.getLayoutParams();
			Map<String, String> touchArea = new HashMap<String, String>();
			touchArea.put("showAreaWidth", String.valueOf(params.width));
			touchArea.put("showAreaHeight", String.valueOf(params.height));
			touchArea.put("clickX", String.valueOf(area[0]));
			touchArea.put("clickY", String.valueOf(area[1]));
			
			ReportEntity entity = new ReportEntity(
					ADConfig.getString(activity, ADConfig.KEY.STRING_APPKEY),
			        ADConfig.getString(activity, ADConfig.KEY.STRING_UUID), 
			        response.getRequestId(), 
			        response.getAdId(),
			        Constants.eventtype.AD_EVENT_CLICK, 
			        1, // 屏幕状态：默认1
			        9999, // 显示时长：默认9999
			        1, // 显示状态：默认1
			        ADConfig.getString(activity, ADConfig.KEY.STRING_INITBACKDATA),
			        response.getRequestBackData(),
			        response.getDisplayTrackerUrlString(), 
			        response.getClickTrackerUrlString(),
			        touchArea, //点击区域1.3.0.2
			        currentTimeMillis-last_show_time, //展示到点击时长1.3.0.2
			        0,0,0
			        );
			Reporter.reportEvent(activity, entity);
		} catch (Exception e)
		{
			ZplayDebug.e(TAG, "onBannerClick report error",e);
		}
	}
		
	/*private enum BannerOrder
	{
		FIRST, NEXT;
	}*/

}